#ifndef REGEXP_H
#define REGEXP_H

#include <utility>
#include <vector>
#include <list>
#include "wstrcnv.h"

typedef std::vector<std::wstring > regexpbuf;

class vmsys {
  class vmct {
  public:
    int ip; /* instruction pointer */
    bool acc; /* acceptable */
    std::vector<std::pair<int, int> > r;
    vmct() {
      ip = 0;
      acc = false;
      r.push_back(std::pair<int, int>(0, 0));
    };
  };
  std::list<vmct> vmcts;
  std::list<std::vector<std::pair<int, int> > > last;
  std::vector<std::pair<int, int> > brefpos;
  regexpbuf e;
  int acct;
  int mc;
  void chksbrf(vmct &vm);
  void chkebrf(vmct &vm);
  bool vmnext(vmct &vm);
  bool istail(const vmct &vm);
  bool matchset(std::wstring e, wchar_t c);
  bool matchone(std::wstring e, wchar_t c);
  void setbrs(vmct &vm);
  void setbre(vmct &vm);
public:
  bool matched();
  bool vmstep(wchar_t c);
  void init(const regexpbuf s);
  void reset();
  vmsys(const regexpbuf s);
  vmsys();
  std::list<std::vector<std::pair<int, int> > > results();
  std::vector<std::pair<int, int> > result();
};

class regexp {
  vmsys vm;
public:
  regexp();
  regexp(const std::wstring s);
  void init(const std::wstring s);
  bool vmdrive(const std::wstring s);
  bool match(const std::wstring s);
  bool search(const std::wstring s);
  std::wstring replace(const std::wstring s, const std::wstring d);
  std::wstring replaceall(const std::wstring s, const std::wstring d);
  std::wstring regexp::editref(
   const std::wstring s, const std::wstring d, 
   const std::vector<std::pair<int, int> > v);
  std::vector<std::pair<int, int> > result();
};

#endif
