/*
 * converts to wchar_t from char
 */

/************************************
 *
 *  Vine 2.1CR ʤɤ˸2001ǯոߤܹ
 *  ǥȥӥ塼ˤ
 *  нˡŪ
 *
 *  1)localeNULLˤmblenؿ顼򵯤
 *    -> ja_JP.eucJPʤɤŪ˻ꤹ
 *
 *  2)4 ʸwstring ws = L"礤";  8word ˤʤäƤޤ
 *    -> ѴؿȤäƱ޽֤Ԥ
 *
 *  3)Standard C++ˤwstringȤʤ
 *    -> gccΥإåեˤХ
 *
 */

#include "wstrcnv.h"

using namespace std;

wstring mtow(const string &s) {
  return mtow(s.c_str(), s.size());
}

wstring mtow(const char *p, size_t len) {
  if (!len) { len = strlen(p); }
  wstring buff;
  int n;
  ::mbtowc(NULL, NULL, 0); // init
  while (*p) {
    if ((n = ::mblen(p, len)) > 0) {
      wchar_t wc;
      ::mbtowc(&wc, p, n);
      buff += wc;
    } else { // ʸɤѤä
      throw runtime_error("CONVERT:MBS->WCS");
    }
    p += n;
    len -= n;
  }
  return buff;
}

string wtom(const wstring &w) {
  string buff;
  int n;
  ::wctomb(NULL, (wchar_t)0); // init
  for (wstring::const_iterator it = w.begin(); it != w.end(); it++) {
    char mb[MB_CUR_MAX];
    if ((n = ::wctomb(mb, *it)) > 0) {
      buff += string(mb, n);
    } else { // ʸɤѤä
      throw runtime_error("CONVERT:WCS->MBS");
    }
  }
  return buff;
}

#ifdef SAMPLE // ưǧѥץ

extern "C" {
#include <locale.h>
}

#include <iostream>
#include <iomanip>

int main() {
  try {
    setlocale(LC_ALL, "ja_JP.eucJP");
    wstring ws = mtow("礤"); 
    for (wstring::iterator it = ws.begin(); it != ws.end(); it++) {
      cout << setw(8) << setfill('0') << hex 
       << (unsigned long)(*it) << " ";
    }
    cout << endl;
    exit(0);
  } catch (exception &e) {
    cout << e.what() << endl;
    exit(1);
  }
}

#endif
